import tester.*;

public class Examples {
	// 5
	IExpr five = new Num(5);
	//	(+ 5 (+7 8))
	IExpr anAdd = new Add(new Num(5.0), new Add(new Num(7), new Num(8)));
	// (- (+ 6 7) 8)
	IExpr aSub = new Sub(new Add(new Num(6), new Num(7)), new Num(8));
	// (* 3 4)
	IExpr aMult = new Mult(new Num(3), new Num(4));
	// (if0 0 1 2)
	IExpr anIfZero = new IfZero(new Num(0), new Num(1), new Num(2));
	// (if0 (- 3 2) 1 2)
	IExpr anotherIfZero = new IfZero(new Sub(new Num(3), new Num(2)), new Num(1), new Num(2));
	// x
	IExpr x = new Var("x");
	// (if0 (- 3 x) 1 2)
	IExpr thirdIfZero = new IfZero(new Sub(new Num(3), x), new Num(1), new Num(2));
		
	void tests(Tester t) {
		t.checkExpect(five.eval(), 5.0);
		t.checkExpect(anAdd.eval(), 20.0);
		t.checkExpect(aSub.eval(), 5.0);
		t.checkExpect(aMult.eval(), 12.0);
		t.checkExpect(anIfZero.eval(), 1.0);
		t.checkExpect(anotherIfZero.eval(), 2.0);
		// x.eval() raises an exception
		t.checkExpect(x.subst("x", 7.0), new Num(7.0));
		t.checkExpect(x.subst("y", 7.0), x);
		t.checkExpect(five.subst("x", 7.0), five);
		t.checkExpect(anAdd.subst("x", 7.0), anAdd);
		t.checkExpect(aSub.subst("x", 7.0), aSub);
		t.checkExpect(aMult.subst("x", 7.0), aMult);
		t.checkExpect(anIfZero.subst("x", 7.0), anIfZero);
		t.checkExpect(thirdIfZero.subst("x", 2.0), anotherIfZero);
	}
}
